Bug 1016807 - Review Request: tubo - Library to thread process std-in/std-err/std-out from fork() child
Review Request: tubo - Library to thread process std-in/std-err/std-out from ...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Mario Blättermann
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 1016809 1018568
  Show dependency treegraph
 
Reported: 2013-10-08 13:47 EDT by Antonio Trande
Modified: 2013-11-10 21:34 EST (History)
5 users (show)

See Also:
Fixed In Version: tubo-5.0.7-2.fc20
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-11-06 02:38:01 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mario.blaettermann: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Antonio Trande 2013-10-08 13:47:36 EDT
Spec URL: http://sagitter.fedorapeople.org/libtubo/tubo.spec
SRPM URL: http://sagitter.fedorapeople.org/libtubo/tubo-5.0.7-1.fc19.src.rpm

Description: 
The Libtubo library is small and simple function set to enable a process to run 
any other process in the background and communicate via the std-out, 
std-err and std-in file descriptors. 
This library is used by Rodent file-manager but is also available here 
for other programs to use freely

Fedora Account System Username: sagitter
Comment 1 Ralf Corsepius 2013-10-08 17:16:55 EDT
Building is silent. It's impossible to check whether the compiler is invoked correctly from log-files.

Please append --disable-silent-rules to %configure.
Comment 2 Antonio Trande 2013-10-09 15:01:38 EDT
(In reply to Ralf Corsepius from comment #1)
> Building is silent. It's impossible to check whether the compiler is invoked
> correctly from log-files.
> 
> Please append --disable-silent-rules to %configure.

Fixed.

Spec URL: http://sagitter.fedorapeople.org/libtubo/tubo.spec
SRPM URL: http://sagitter.fedorapeople.org/libtubo/tubo-5.0.7-2.fc19.src.rpm
Comment 3 Mario Blättermann 2013-10-14 14:58:26 EDT
Scratch build for Rawhide:
http://koji.fedoraproject.org/koji/taskinfo?taskID=6059678

$ rpmlint -i -v *
tubo.src: I: checking
tubo.src: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo.src: W: strange-permission tubo-5.0.7.tar.gz 0600L
A file that you listed to include in your package has strange permissions.
Usually, a file should have 0644 permissions.

tubo.src: I: checking-url http://sourceforge.net/projects/xffm/files/libtubo/tubo-5.0.7.tar.gz (timeout 10 seconds)
tubo.armv7hl: I: checking
tubo.armv7hl: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo.i686: I: checking
tubo.i686: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo.x86_64: I: checking
tubo.x86_64: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-debuginfo.armv7hl: I: checking
tubo-debuginfo.armv7hl: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-debuginfo.armv7hl: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo_static.i
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-debuginfo.armv7hl: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo.c
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-debuginfo.i686: I: checking
tubo-debuginfo.i686: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-debuginfo.i686: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo_static.i
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-debuginfo.i686: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo.c
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-debuginfo.x86_64: I: checking
tubo-debuginfo.x86_64: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo_static.i
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo.c
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-devel.armv7hl: I: checking
tubo-devel.armv7hl: W: summary-not-capitalized C tubo headers and development-related files
Summary doesn't begin with a capital letter.

tubo-devel.armv7hl: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-devel.armv7hl: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

tubo-devel.armv7hl: E: incorrect-fsf-address /usr/include/tubo.h
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-devel.i686: I: checking
tubo-devel.i686: W: summary-not-capitalized C tubo headers and development-related files
Summary doesn't begin with a capital letter.

tubo-devel.i686: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-devel.i686: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

tubo-devel.i686: E: incorrect-fsf-address /usr/include/tubo.h
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-devel.x86_64: I: checking
tubo-devel.x86_64: W: summary-not-capitalized C tubo headers and development-related files
Summary doesn't begin with a capital letter.

tubo-devel.x86_64: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-devel.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

tubo-devel.x86_64: E: incorrect-fsf-address /usr/include/tubo.h
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo.spec: I: checking-url http://sourceforge.net/projects/xffm/files/libtubo/tubo-5.0.7.tar.gz (timeout 10 seconds)
10 packages and 1 specfiles checked; 9 errors, 7 warnings.



The old FSF addresses have to be reported upstream.

To make rpmlint happy regarding the not-capitalized summary, you might use the following template, which you get anyway when creating a new spec with rpmdev-newspec:

Summary:        Development files for %{name}
...
%description    devel
The %{name}-devel package contains libraries and header files for
developing applications that use %{name}.

It isnot really dangerous to let the tarball have the mentioned permissions, but you could change it to 0644 as proposed before creating the srpm.

(In reply to Ralf Corsepius from comment #1)
> Building is silent. It's impossible to check whether the compiler is invoked
> correctly from log-files.

After adding this rule and building the library on Koji, I can't see any peculiarities. Ralf, please have a look at build.log:
http://kojipkgs.fedoraproject.org//work/tasks/9680/6059680/build.log
If you don't have any further objections, I would complete this review.
Comment 4 Mario Blättermann 2013-10-14 15:38:13 EDT
Still one more issue, though.

%dir %{_datadir}/gtk-doc/html/lib%{name}
%{_datadir}/gtk-doc/html/lib%{name}/*

In this case the whole folder path /usr/share/gtk-doc/html would stay unowned. No problem, you could simply add "Requires: gtk-doc" and all is fine. That package is quite small and doesn't eat up a lot of disk space. But it has a disadvantage, it pulls a lot of dependencies, and gtk-doc is actually not needed for libtubo at runtime. In such cases, it is allowed and usual to co-own the whole folder %{_datadir}/gtk-doc and don't require gtk-doc at all. I can't find the appropriate guideline for the time being, just have a look at the first entry of the associated tracking bug:
https://bugzilla.redhat.com/show_bug.cgi?id=604169#c0

And last but not least, a wrong comment has crept in your spec:

## Remove static libs
find $RPM_BUILD_ROOT -name '*.la' -delete

The same as in your librfm review ticket, you know what to do ;)
Comment 5 Antonio Trande 2013-10-14 17:02:20 EDT
> A file that you listed to include in your package has strange permissions.
> Usually, a file should have 0644 permissions.

Fixed.

> The Free Software Foundation address in this file seems to be outdated or
> misspelled.  Ask upstream to update the address, or if this is a license file,
> possibly the entire file with a new copy available from the FSF.

https://sourceforge.net/p/xffm/support-requests/2/

> In such cases, it is allowed and usual to co-own the whole folder %
> {_datadir}/gtk-doc and don't require gtk-doc at all. I can't find the 
> appropriate guideline for the time being, just have a look at the first entry 
> of the associated tracking bug:
> https://bugzilla.redhat.com/show_bug.cgi?id=604169#c0

Something like that is debated is the Guidelines: https://fedoraproject.org/wiki/Packaging:Guidelines#The_directory_is_owned_by_a_package_which_is_not_required_for_your_package_to_function

In this way it should be okay:

Spec URL: http://sagitter.fedorapeople.org/libtubo/tubo.spec
SRPM URL: http://sagitter.fedorapeople.org/libtubo/tubo-5.0.7-2.fc19.src.rpm
Comment 6 Antonio Trande 2013-10-16 14:31:47 EDT
@Mario

Have you some other observation ?
Comment 7 Mario Blättermann 2013-10-16 14:35:20 EDT
%dir %{_datadir}/gtk-doc
%dir %{_datadir}/gtk-doc/html
%dir %{_datadir}/gtk-doc/html/lib%{name}
%{_datadir}/gtk-doc/html/lib%{name}/*

The last three lines can be omitted. Just write %{_datadir}/gtk-doc to own the whole folder. To own the parts of the folder path and the files separately doesn't make a difference.

@Ralf, if you don't have any further objections, I would complete the review after the mentioned issue has been fixed.
Comment 9 Antonio Trande 2013-10-25 11:16:00 EDT
Any progress ? :)
Comment 10 Mario Blättermann 2013-10-25 13:37:40 EDT
Scratch build:
http://koji.fedoraproject.org/koji/taskinfo?taskID=6099427

$ rpmlint -i -v *
tubo.src: I: checking
tubo.src: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo.src: I: checking-url http://sourceforge.net/projects/xffm/files/libtubo/tubo-5.0.7.tar.gz (timeout 10 seconds)
tubo.armv7hl: I: checking
tubo.armv7hl: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo.i686: I: checking
tubo.i686: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo.x86_64: I: checking
tubo.x86_64: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-debuginfo.armv7hl: I: checking
tubo-debuginfo.armv7hl: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-debuginfo.armv7hl: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo.c
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-debuginfo.armv7hl: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo_static.i
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-debuginfo.i686: I: checking
tubo-debuginfo.i686: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-debuginfo.i686: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo_static.i
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-debuginfo.i686: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo.c
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-debuginfo.x86_64: I: checking
tubo-debuginfo.x86_64: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo_static.i
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-debuginfo.x86_64: E: incorrect-fsf-address /usr/src/debug/tubo-5.0.7/src/tubo.c
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-devel.armv7hl: I: checking
tubo-devel.armv7hl: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-devel.armv7hl: E: incorrect-fsf-address /usr/include/tubo.h
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-devel.i686: I: checking
tubo-devel.i686: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-devel.i686: E: incorrect-fsf-address /usr/include/tubo.h
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo-devel.x86_64: I: checking
tubo-devel.x86_64: I: checking-url http://xffm.org/libtubo.html (timeout 10 seconds)
tubo-devel.x86_64: E: incorrect-fsf-address /usr/include/tubo.h
The Free Software Foundation address in this file seems to be outdated or
misspelled.  Ask upstream to update the address, or if this is a license file,
possibly the entire file with a new copy available from the FSF.

tubo.spec: I: checking-url http://sourceforge.net/projects/xffm/files/libtubo/tubo-5.0.7.tar.gz (timeout 10 seconds)
10 packages and 1 specfiles checked; 9 errors, 0 warnings.


Besides the known issues about wrong FSF addresses, nothing of interest.


---------------------------------
key:

[+] OK
[.] OK, not applicable
[X] needs work
---------------------------------

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build produces. The output should be posted in the review.
[+] MUST: The package must be named according to the Package Naming Guidelines.
[+] MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines.
[+] MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines.
[+] MUST: The License field in the package spec file must match the actual license.
    GPLv3+
[+] MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.
[+] MUST: The spec file must be written in American English.
[+] MUST: The spec file for the package MUST be legible.
[+] MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use sha256sum for this task as it is used by the sources file once imported into git. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
    $ sha256sum *
    ecec421d480cc90eaed0cabf9fb5d8322cd6b8a1930bda715e48776da7105819  tubo-5.0.7.tar.gz
    ecec421d480cc90eaed0cabf9fb5d8322cd6b8a1930bda715e48776da7105819  tubo-5.0.7.tar.gz.orig

[+] MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture.
[.] MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line.
[+] MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
[.] MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[+] MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun.
[+] MUST: Packages must NOT bundle copies of system libraries.
[.] MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker.
[+] MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory.
    The known exception for gtk-doc has been applied.

[+] MUST: A Fedora package must not list a file more than once in the spec file's %files listings. (Notable exception: license texts in specific situations)
[+] MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example.
[+] MUST: Each package must consistently use macros.
[+] MUST: The package must contain code, or permissable content.
[.] MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity).
[+] MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present.
[.] MUST: Static libraries must be in a -static package.
[+] MUST: Development files must be in a -devel package.
[+] MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name}%{?_isa} = %{version}-%{release}
[+] MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.
[.] MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation.
[+] MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. 
[+] MUST: All filenames in rpm packages must be valid UTF-8.


[.] SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it.
[.] SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available.
[+] SHOULD: The reviewer should test that the package builds in mock.
    See Koji build above (which uses Mock anyway).
[+] SHOULD: The package should compile and build into binary rpms on all supported architectures.
[.] SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
[+] SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity.
[.] SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency.
[+] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb.
[.] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself.
[.] SHOULD: your package should contain man pages for binaries/scripts. If it doesn't, work with upstream to add them where they make sense.


----------------

PACKAGE APPROVED

----------------
Comment 11 Antonio Trande 2013-10-25 15:54:33 EDT
Thank you, Mario.

New Package SCM Request
=======================
Package Name: tubo
Short Description: Library to thread process std-in/std-err/std-out from fork() child
Owners: sagitter
Branches: f19 f20 el6
Comment 12 Gwyn Ciesla 2013-10-28 08:09:39 EDT
Git done (by process-git-requests).
Comment 13 Fedora Update System 2013-10-28 12:25:54 EDT
tubo-5.0.7-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/tubo-5.0.7-2.fc19
Comment 14 Fedora Update System 2013-10-28 12:26:07 EDT
tubo-5.0.7-2.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/tubo-5.0.7-2.el6
Comment 15 Fedora Update System 2013-10-28 12:26:19 EDT
tubo-5.0.7-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/tubo-5.0.7-2.fc20
Comment 16 Fedora Update System 2013-10-28 14:42:32 EDT
tubo-5.0.7-2.el6 has been pushed to the Fedora EPEL 6 testing repository.
Comment 17 Fedora Update System 2013-11-06 02:38:01 EST
tubo-5.0.7-2.fc19 has been pushed to the Fedora 19 stable repository.
Comment 18 Fedora Update System 2013-11-06 11:13:29 EST
tubo-5.0.10-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/tubo-5.0.10-2.fc19
Comment 19 Fedora Update System 2013-11-06 11:13:42 EST
tubo-5.0.10-2.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/tubo-5.0.10-2.fc20
Comment 20 Fedora Update System 2013-11-06 11:13:53 EST
tubo-5.0.10-2.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/tubo-5.0.10-2.el6
Comment 21 Fedora Update System 2013-11-10 01:24:18 EST
tubo-5.0.7-2.fc20 has been pushed to the Fedora 20 stable repository.
Comment 22 Fedora Update System 2013-11-10 21:34:14 EST
tubo-5.0.10-2.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.